
/*
 *  GENESIS  Copyright (c) 1986, 1990 by John J. Grefenstette
 *  This program may be freely copied for educational
 *  and research purposes.  All other rights reserved.
 *
 *  file:	define.h
 *
 *  purpose:	global definitions for genesis
 */
 
/************************ INCLUDE FILES ***********************/

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>




/***** MACRO DE TIPO DE PROBLEMA: MAXIMIZACION/MINIMIZACION  *****/

/* Comparacion de dos valores de fitness. Si se minimiza es < (X es mejor que
   Y si su valor es mas pequenyo) y si se maximiza es > (X es mejor que Y si
   su valor es mas grande).
   
   En este codigo, para el problema de maximizar el numero de unos se pondria
   > y para minimizar el numero de ceros, se pondria < */
#define BETTER(X,Y)	((X) > (Y))




/********************** SYSTEM DEPENDENCIES *******************/

/* Be sure to set exactly one of the following			*/
/* Set UNIX for Vax or Sun (or other 32-bit UNIX systems)	*/
/* Set TURBOC for Turbo C for DOS systems			*/

#define TURBOC	0
#define UNIX	1

#if UNIX

#include <curses.h>

#else

/* the following provide functions similar to UNIX <curses.h> */
#include <conio.h>
#define clrtoeol	clreol
#define refresh()	fflush(stdout)
#define printw		printf
#define scanw		scanf
#define getw		gets

#endif



/************************ TYPES ******************************/

/* tipo de dato del gen */
typedef char TipoGen;

/* tipo de dato del cromosoma */
typedef TipoGen *TipoCromosoma;

/* each member of the population has this form */
typedef struct {
	TipoCromosoma Gene;
	float fitness;
        float n_e;
} STRUCTURE;

/* the best structures are saved in the following record */
typedef struct {
	short int *Gene;
	float fitness;
	int Gen;
} BESTSTRUCT;



/***** GENERADOR DE NUMEROS PSEUDOALETORIOS *****/

/* used in random number generator below */
#define MASK 2147483647
#define PRIME 65539
#define SCALE 0.4656612875e-9

/*******************************************************************/
/*  Rand genera un numero real pseudoaleatorio entre 0 y 1,        */
/*  excluyendo el 1.						   */
/*  Randint genera un numero entero entre low y high, ambos 	   */
/*  incluidos.	   						   */
/*  Randfloat genera un numero real entre low y high, incluido low */
/*  y no incluido high                                             */
/*******************************************************************/

#define Rand()  (( Seed = ( (Seed * PRIME) & MASK) ) * SCALE )

#define Randint(low,high) ( (int) (low + (high-(low)+1) * Rand()))

#define Randfloat(low,high) ( (low + (high-(low))*Rand()))

/** end of file **/
