#include "extern.h"

#define FORMATO_ENT "Numero de variables = %d \
Numero de Generaciones = %d \
Longitud de la Poblacion = %d \
Probabilidad de Cruce = %f \
Probabilidad de Mutacion (por cromosoma) = %f \
Tamao del torneo = %d \
Semilla = %f"

#define VAR_ENT  &n_genes,&n_generaciones,&long_poblacion,\
                 &prob_cruce,&prob_mutacion,&tam_torneo,&semilla



void Input (int argc, char *argv[])

/* Funcion que efectua la lectura de los datos de entrada desde el fichero
   entradas */

{
 int i, j;
 FILE *fp;
 char fichero_ent[100], fichero_sal[100];

 /* Se procede a la lectura de los datos de entrada */
 sprintf (fichero_ent,"%s",argv[1]);
 if ((fp=fopen (fichero_ent,"r")) == NULL)
  {
   printf ("No se puede abrir el fichero de datos de entrada %s",fichero_ent);
   abort ();
   }
 fscanf (fp,FORMATO_ENT,VAR_ENT);
 fclose (fp);
 Seed=(unsigned long) semilla;
 
 /* Asignamos a eval la funcion de adaptacion empleada. Podriamos tener varias y
    escogerlas en funcion de parametros de entrada.
    
    OJO: Ademas, hemos de acordarnos de definir correctamente el tipo de problema,
    maximizacion o minimizacion, en la macro BETTER (define.h)*/
 eval=eval_unos;
 /* eval=eval_ceros; */
 
 
 /* Calculo de la probabilidad de mutacion a nivel de gen */
 prob_mutacion=prob_mutacion/(float)n_genes;


 /* Reserva de memoria para las poblaciones */
 Old = (STRUCTURE *) calloc ((unsigned) long_poblacion, sizeof(STRUCTURE));
 New = (STRUCTURE *) calloc ((unsigned) long_poblacion, sizeof(STRUCTURE));
 if (Old == NULL || New == NULL)
  {
   printf("Error en Calloc 1");
   abort();
   }

 for (i=0; i<long_poblacion; i++)
  {
	Old[i].Gene = (TipoCromosoma) calloc ((unsigned)n_genes,sizeof(TipoGen));
	New[i].Gene = (TipoCromosoma) calloc ((unsigned)n_genes,sizeof(TipoGen));
   if (Old[i].Gene == NULL || New[i].Gene == NULL)
    {
     printf("Error en Calloc 2");
     abort();
     }
   }


 /* Reserva de memoria para el vector de probabilidades acumuladas que representa
    la ruleta en el mecanismo de seleccion (select.c) */
 Ruleta = (float *) calloc ((unsigned) long_poblacion,sizeof(float));
 if (Ruleta == NULL)
  {
   printf("Error en Calloc 1");
   abort();
   }

 /* Reserva de memoria para la estructura que almacena los indices de los 
    individuos seleccionados para competir en el torneo */
 Torneo = (int *) calloc ((unsigned)tam_torneo,sizeof(int));
 if (Torneo == NULL)
  {
   printf("Error en la reserva de memoria de la estructura Torneo");
   abort();
   }


 /* Reserva de memoria para el vector en el que se almacena los indices de los
    individuos de la poblacion antigua que han sido seleccionados para la
    poblacion intermedia (select.c) */
 sample = (int *) calloc ((unsigned) long_poblacion,sizeof(int));
 if (sample == NULL)
  {
   printf("Error en Calloc 4");
   abort();
   }

 }

